#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "raze.h"
#include "z80.h"
#include <allegro.h>


#define XLEN 256
#define YLEN 256

// Based on SinVader by Mike Green

void NMI(void);

void NMI()
{   
void  z80_cause_NMI();
IFlag=1;
}
END_OF_FUNCTION(NMI);

void ShowHelp()
{
        printf("Laser 0.21 Beta 1.  Based on SinVader by Mike Green\n");
        printf("Happy Birthday to David Lloyd of OverClocked!\n");
        printf("Usage:     laser gamename [options]\n");
        printf("Options:   -?,-h        Show this help text\n");
        exit(0);
}

int FindOption(char *option, int p, int h, int u, int argc, char **argv)
{
        static int      t[] = { 0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0 };
        int             i;
        char            *c;
      
        if (argc > 128)
                argc = 128;     /* maximum this function can handle is 128 */

        /*
         * if p = 1 and h = 0 will find option and return decimal value of
         * argv[i+1], if h = 1 will read it as hex.
         * if p = 0 then it will return index of option in argv[], 0 not found
         * if u = 1 will return index of first occurance of untouched option
         */

        if (u)  /* find first untouched element */
        {
                for (i = 1; i < argc; i++)
                {
                        if (!t[i])      /* 0 indicates untouched */
                                return i;
                }
                return 0;
        }

        if (p)  /* find option and return integer value following it */
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)       /* found */
                        {
                                if (i >= argc)                  /* bounds! */
                                        return 0;
                                t[i + 1] = t[i] = 1;            /* touched */
                                if (!h)
                                        return atoi(argv[i + 1]);
                                else
                                        return strtoul(argv[i + 1], &c, 16);
                        }
                }
                return 0;                                       /* no match */
        }
        else    /* find option and return position */        
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)
                        {
                                t[i] = 1;
                                return i;       /* found! return position */
                        }
                }                                                          
                return 0;
        }
        return 0;
}


int i;
int numbo=0;
UBYTE bGame;
reg z80reg;
UBYTE *pbROM;
UBYTE *pbRAM;
UBYTE bShiftValue = 0;
UBYTE bBitmap = 0;
UBYTE bBitmapPrevious = 0;
DATAFILE *audio;

UBYTE *RAM;
PALLETE invaders_pal; 
reg R;
FILE *in;
BITMAP *buffer;

int colf[10],colb[10]={16,32,48,64,80,96,112,128,144,160};

int main(int argc, char **argv)
{

             
	/* check command line for no options, process help */
        if (argc == 1)                                  /* show help */
                ShowHelp();
        if (FindOption("-?", 0, 0, 0, argc, argv) ||
            FindOption("-h", 0, 0, 0, argc, argv))
                ShowHelp();

        
	allegro_init(); 
	set_gfx_mode(GFX_MODEX, 256, 256, 0, 0);

        invaders_pal[0].r = invaders_pal[0].g = invaders_pal[0].b = 0;
        for (i = 1; i < 256; i++)
        {
                invaders_pal[i].r = invaders_pal[i].g =
invaders_pal[i].b = 0xf1;
        }
        set_palette(invaders_pal);

 	install_timer();
	install_keyboard();
	initialise_joystick();
	set_projection_viewport(0, 0, SCREEN_W, SCREEN_H);
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
   	clear(buffer);	
			
	
	/* ok time to load the roms! */
          if (FindOption("invaders", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

	  else
          if (FindOption("spaceatt", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/spaceatt/Spaceatt.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/spaceatt/Spaceatt.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400
		  
		  in = fopen("roms/spaceatt/Spaceatt.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
		  
		  in = fopen("roms/spaceatt/Spaceatt.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }


          else
          if (FindOption("earthinv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/earthinv/Earthinv.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/earthinv/Earthinv.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/earthinv/Earthinv.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/earthinv/Earthinv.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("si_cv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/SI_CV/Cv17.bin", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/SI_CV/Cv18.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/SI_CV/Cv19.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/SI_CV/Cv20.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

	LOCK_FUNCTION(NMI);
	install_int(NMI,8);

  clear(screen);                              //and clear the screen

      z80_reset();     //This resets the Z80 to its proper starting values
      Z80(R);          //Actually starts the emulation

return 0;
}


void M_WRMEM(UWORD A,UBYTE V)
{
int x,y;

	if ( A < 0x2000)
	{

	return;
	}

	  RAM[A] = V;
	  
	if ( A > 0x23ff && A < 0x4000 ) // We must be trying to write to the screen!

	{
		i = (A - 0x2400 );
		x = i / 32;
		y = 8 * (i % 32);

        

                for (i = 0; i < 8; i++)
                {
                        putpixel(screen, x, 256-y, V & 1);
                        y++;
                        V >>= 1;
                }
		 
	}


}


UBYTE M_RDMEM(UWORD A)
{
	if ( A > 0x3f00 ) return(0);
	return(RAM[A]);
}


/*** Input/Output values from/to ports: *******************/
/*** These are called on IN and OUT commands and should ***/
/*** supplied by machine-dependent part of the code.    ***/
/**********************************************************/
UBYTE DoIn(UBYTE Port)
{
	UWORD wValue;
	UBYTE bValue;
	switch(Port) {
		case 1:
			bValue=0x81;
			poll_joystick();
			if (joy_left)  bValue|=0x20; 
			if (joy_right) bValue|=0x40; 
			if (joy_b1) bValue|=0x10;
			if (key[KEY_ESC]) 
			{
			clear(screen); 
			set_gfx_mode(GFX_TEXT,80,25,0,0); 
			printf("LASER 0.21 Beta 1\nHappy Birthday David Lloyd of Overclocked!\nBased On SinVader by Mike Green.\nZ80 Core by Marat Fayzullin\n");			
			exit(0);
			}
			if(key[KEY_1]) bValue|=0x04;
			if(key[KEY_2]) bValue|=0x02;
			if(key[KEY_3]) bValue&=~0x01;
			if(key[KEY_LEFT]) bValue|=0x20;
			if(key[KEY_RIGHT]) bValue|=0x40;
			if(key[KEY_SPACE]) bValue|=0x10;
			return(bValue);
		case 2:
			bValue=0;
			if(key[KEY_T]) bValue=0x04;
			if(key[KEY_P]) bValue=0x08;
			if(bGame!=1) {
				if(key[KEY_LEFT]) bValue|=0x20;
				if(key[KEY_RIGHT]) bValue|=0x40;
				if(key[KEY_SPACE]) bValue|=0x10;
			}
			return(bValue);
		case 3:
			wValue=(bBitmap<<8)|bBitmapPrevious;
			wValue=wValue<<bShiftValue;
			bValue=(UBYTE)(wValue>>8);
			return(bValue);
		default:
			return(0x00);
	}
}

void DoOut(UBYTE Port,UBYTE Value)
{

	switch(Port) {
		case 2:
			bShiftValue=Value;
			break;
		case 4:
			bBitmapPrevious=bBitmap;
			bBitmap=Value;
			break;
	}
}


/**********************************************************/
/*** Emulate BIOS calls. This function is called on the ***/
/*** ED FE instruction to emulate disk/tape access, etc.***/
/*** Replace it with an empty macro for now patching.   ***/
/**********************************************************/
void Patch(reg *R)
{
}


UWORD Interrupt()
{
  static UBYTE bNMI = 0;
  if(bNMI++&0x01) return(0x0010);
  return(0x0008);
}

